"""
Summarizing File IO in Python

This program is provided to review file io and check you understanding of 3 different ways to read files (read3 is the approach you will see El use
most). Tip: For the debugging read1 exercise, try testing it out first
with readfile('key.txt'), and compare the output with the intended output.

Can you walk through the code to see why it's different? You can also use
the VSCode debugger with a breakpoint in read1 to step over and see where
it goes wrong! This is a very useful debugging strategy for MP3.
"""

# Using key file for Scantron grader just for example KEY_FILE = 'key.txt'
KEY_FILE = 'key.txt'

def read1(filename):
    """
    Buggy example that reads given file and outputs it as you might
    see in VSCode, in the form:
    1: <linetext>
    2: <linetext>
    ...
    <lastline>: <linetext>

    Example:
    1. A
    2. B
    ...
    20. C
    """
    f = open(filename, 'r')
    line_count = 0
    while True:
        if f.readline() == '':
            break  # exit while loop

        line = f.readline()
        line_count += 0
        print(f'{line_count}: {line}')
    f.close() # close the file explicitly if not using `with`


# Version with `with` and `f.readline()` (on your own)
def read2(filename):
    with open(filename, 'r') as f:
        # ... do stuff
        # implicit f.close() when with block ends
        pass


# Version with with and `for line in f` (El uses this more)
def read3(filename):
    with open(filename, 'r') as f:
        line_counter = 0
        for line in f:
            line_counter += 1
            print(f'{line_counter}: {line}')


read1(KEY_FILE)
