"""
A 'real-world' file i/o application that processes Scantron
exam results as .txt files and compares them with a key.txt
solution set.

Requirements for proper program use:
Each test file should be in the format:
samples/testN.txt
and (with key.txt) should have exactly one character per line.

Each test file should have exactly the same number of lines
as key.txt
--------------------------------------------------
Exercises (in lecture):
- Write a function grade_scantron which takes a filename
  string as an argument and compares the contents with
  key.txt. For now, you can assume the given filename exists
  (in practice, throwing an exception would be best but we
  haven't gotten to exception-handling yet) though you can
  handle the case with a print statement/skipping normal
  behavior if you'd like.
  - Design decisions:
    - How do you efficiently (and cleanly) process two files at once?
    - Are there design trade-offs you might run into?
    - There are two reasonable outputs for this function:
      1. Print the results at the end of the function:
        <filename> Results: X of Y correct (ZZ.Z%)
      2. Return the results in some way for use outside
        of the function.
      - Which do you think is best? Why?
    - Are there parts of the function you can factor out with
      a helper function?
    - How (and how often) should you test your function?
Example run-through (in interpreter):
>>> grade_scantron('samples/test1.txt')
  sample/test1.txt: 17 of 20 correct (85.0%)
"""

# Example from lecture of using `for line in f` instead of while loop
# with open('aqis.txt', 'r') as f:
#   for line in f:
#     total += 1
#     if int(line) > 150:
#       aqis_above_150 += 1

# Note: We could add an improvement with a second argument for
# the key file to generalize the program in case there are 
# multiple assignment sets.
def grade_scantron(filename):
  """
  Calculates the number of correct out of total answers
  for the given filename compared to the key file. Prints the
  results in the format:
    <filename>: X of Y correct (ZZ.Z%)
  Assumptions: key.txt and `filename` have exactly the
  same number of lines with exactly one character per line.
  Also assumes no empty answers.
  """
  KEYFILE_NAME = 'key.txt'
  # TODO: Write your own process for how you would grade samples/test1.txt against key.txt
  # TODO: Translate to Python!
  # print(f'{filename}: {num_correct} of {total_lines} correct ({grade:.1f}%)')
  return


def main():
  """
  Prompts the user to enter a scantron file to grade and output the
  results.
  """
  print('Welcome to the Scantron Grader!')
  test_filename = input('Please enter a scantron file name to grade: ')
  # TODO: Call grade_scantron to process the specified file


if __name__ == '__main__':
  main()

# Challenge exercises:
# - Add a function to convert a percentage grade to a letter grade
# - Add an improved function to not only print the grade,
#   but also the lines which were mismatching between the key
#   and test file.
# - Improve error-handling when a test file has incorrect format or
#   different number of lines compared to the key
# - Loop through X test files to print results for each instead
#   of X separate grade_scantron files
# - Add a header to each test file with a user email (e.g. lhovik@caltech.edu)
#   Modify the grade_scantron function to skip this header when comparing scores with
#   the key, and print the final result as: 
#   <email> results: X of Y correct (ZZ.ZZ%)
